/*
//
//              INTEL CORPORATION PROPRIETARY INFORMATION
//     This software is supplied under the terms of a license agreement or
//     nondisclosure agreement with Intel Corporation and may not be copied
//     or disclosed except in accordance with the terms of that agreement.
//        Copyright(c) 2012-2013 Intel Corporation. All Rights Reserved.
//
*/

#include <jni.h>
#include <string.h>

#include "ipp.h"

JNIEXPORT jstring JNICALL
Java_com_example_testippadd_ArrayAddActivity_NativeIppAdd(JNIEnv* env,
                                                        jobject thiz
                                                 )
{
    //call this function before any ipp function call;
    ippInit();

    float  a1[4]={1,2,3,4};  
    float  a2[4]={5,6,7,8};
    float  a12[4];                   
    IppStatus status;    
   
 
    //ipp function call:  a12[i]=a1[i]+a2[i]
    status = ippsAdd_32f(a1,a2,a12,4); 
   

    //create a string to show in the UI 
    char*  str, buffer[100];
    asprintf(&str, "a1=%.1f, %.1f, %.1f, %.1f\na2=%.1f, %.1f, %.1f, %.1f\na1+a2=%.1f, %.1f, %.1f, %.1f",
                       a1[0],a1[1],a1[2],a1[3],a2[0],a2[1],a2[2],a2[3],a12[0],a12[1],a12[2],a12[3]);
    strcpy(buffer,str);
    free(str);

    return (*env)->NewStringUTF(env, buffer);
    
}

